# plpgsql_sec

`plpgsql_sec` is an implementation of the PL/pgSQL procedural language that
encrypts and decrypts function bodies on the fly. It helps hiding
implementation of PL/pgSQL functions. The encryption/decryption uses the
pgcrypto module from PostgreSQL.

# INSTALL

```bash
PG_VER=16 # Set the desired PostgreSQL major version.
git clone git@github.com:cybertec-postgresql/plpgsql_sec.git
cd plpgsql_sec
git switch PG_${PG_VER}
make # `pg_config` must be in your $PATH.
     # alternatively: make PG_CONFIG=/usr/lib/postgresql/$PG_VER/bin/pg_config
make install # Possibly with `sudo`.
```

# SETUP

1. Install the extension, either build it yourself or the binary package.
2. Put the encryption password into the `$PGDATA/plpgsql_sec_passwd` file.
3. Start the instance
4. Connect to your database as superuser and run `CREATE EXTENSION plpgsql_sec;`

# USAGE

From this point you can pass `plpgsql_sec` language to the `CREATE FUNCTION`
command:

```
CREATE OR REPLACE FUNCTION func_name(... ) ... LANGUAGE plpgsql_sec;
```

The function body will now be stored encrypted.

If such a function is dumped and reloaded then the encryption scheme is
recognized and encryption is skipped, the function is stored with the already
provided encryption.

**The encryption key is located in the data directory. Therefore,
the function text can potentially be decrypted by the superuser, as well as by
any user who has the `EXECUTE` permission on the appropriate [file access
functions][1] or is granted the appropriate [predefined role][2].**

[1]: https://www.postgresql.org/docs/current/functions-admin.html#FUNCTIONS-ADMIN-GENFILE
[2]: https://www.postgresql.org/docs/current/predefined-roles.html
