/* src/pl/plpgsql/src/plpgsql--1.0.sql */

CREATE FUNCTION plpgsql_sec_call_handler() RETURNS language_handler
  LANGUAGE c AS 'MODULE_PATHNAME';

CREATE FUNCTION plpgsql_sec_inline_handler(internal) RETURNS void
  STRICT LANGUAGE c AS 'MODULE_PATHNAME';

CREATE FUNCTION plpgsql_sec_validator(oid) RETURNS void
  STRICT LANGUAGE c AS 'MODULE_PATHNAME';

CREATE TRUSTED LANGUAGE plpgsql_sec
  HANDLER plpgsql_sec_call_handler
  INLINE plpgsql_sec_inline_handler
  VALIDATOR plpgsql_sec_validator;

-- The language object, but not the functions, can be owned by a non-superuser.
ALTER LANGUAGE plpgsql_sec OWNER TO @extowner@;

COMMENT ON LANGUAGE plpgsql_sec IS 'PL/pgSQL procedural language';
